Index: /trunk/source/geometry/magneticfield/include/G4CachedMagneticField.hh
===================================================================
--- /trunk/source/geometry/magneticfield/include/G4CachedMagneticField.hh	(revision 1274)
+++ /trunk/source/geometry/magneticfield/include/G4CachedMagneticField.hh	(revision 1274)
@@ -0,0 +1,83 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+//
+// $ Id: G4CachedMagneticField.hh,v 1.0 2009/07/20 18:53:00 japost Exp $
+// GEANT4 tag $Name:  $
+//
+//
+// class G4CachedMagneticField
+//
+// Class description:
+//
+// Caches Magnetic Field value, for field whose evaluation is expensive.
+
+// History:
+// - Created. JA, July 20th, 2009.
+// --------------------------------------------------------------------
+
+#ifndef G4CACHED_MAGNETIC_FIELD_DEF
+#define G4CACHED_MAGNETIC_FIELD_DEF
+
+#include "G4Types.hh"
+#include "G4ThreeVector.hh"
+#include "G4MagneticField.hh"
+
+class G4CachedMagneticField : public G4MagneticField
+{
+  public:  // with description
+
+     G4CachedMagneticField(G4MagneticField *, G4double distanceConst);
+     virtual ~G4CachedMagneticField();
+       // Constructor and destructor. No actions.
+
+     G4CachedMagneticField(const G4CachedMagneticField &r);
+     G4CachedMagneticField& operator = (const G4CachedMagneticField &p);
+       // Copy constructor & assignment operator.
+
+     virtual void  GetFieldValue( const G4double Point[4],
+                                        G4double *Bfield ) const;
+     
+     G4double GetConstDistance() const         { return fDistanceConst; } 
+     void     SetConstDistance( G4double dist ){ fDistanceConst= dist;}
+
+     G4int GetCountCalls() const { return fCountCalls; }
+     G4int GetCountEvaluations() const { return fCountEvaluations; } 
+     void  ClearCounts() { fCountCalls = 0; fCountEvaluations=0; }
+     void  ReportStatistics();
+
+  private: 
+     G4MagneticField *fpMagneticField;
+     // When the field is evaluated within this distance it will not change
+     G4double      fDistanceConst;
+     // Caching state
+     mutable G4ThreeVector fLastLocation;
+     mutable G4ThreeVector fLastValue;
+
+  protected:
+     mutable G4int fCountCalls, fCountEvaluations;  
+};
+
+#endif /* G4CACHED_MAGNETIC_FIELD_DEF */
Index: /trunk/source/geometry/magneticfield/include/G4EqEMFieldWithEDM.hh
===================================================================
--- /trunk/source/geometry/magneticfield/include/G4EqEMFieldWithEDM.hh	(revision 1274)
+++ /trunk/source/geometry/magneticfield/include/G4EqEMFieldWithEDM.hh	(revision 1274)
@@ -0,0 +1,91 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+//
+// $Id: G4EqEMFieldWithEDM.hh,v 1.1 2009/11/04 23:51:42 gum Exp $
+// GEANT4 tag $Name:  $
+//
+//
+// class G4EqEMFieldWithEDM
+//
+// Class description:
+//
+// This is the right-hand side of equation of motion in a combined
+// electric and magnetic field, with spin tracking for both MDM and
+// EDM terms.
+
+// History:
+// - Created. Kevin Lynch, 19.02.2009, based on G4EqEMFieldWithSpin
+// -------------------------------------------------------------------
+
+#ifndef G4EQEMFIELDWITHEDM_hh
+#define G4EQEMFIELDWITHEDM_hh
+
+#include "G4EquationOfMotion.hh"
+
+class G4ElectroMagneticField;
+
+class G4EqEMFieldWithEDM : public G4EquationOfMotion
+{
+  public:  // with description
+
+    G4EqEMFieldWithEDM(G4ElectroMagneticField *emField );
+
+    ~G4EqEMFieldWithEDM();
+  
+    void  SetChargeMomentumMass(G4double particleCharge, // in e+ units
+                                G4double MomentumXc,
+                                G4double mass);
+
+    void EvaluateRhsGivenB(const G4double y[],
+                           const G4double Field[],
+                                 G4double dydx[] ) const;
+      // Given the value of the electromagnetic field, this function 
+      // calculates the value of the derivative dydx.
+
+    inline void SetAnomaly(G4double a) { anomaly = a; }
+    inline G4double GetAnomaly() const { return anomaly; }
+      // set/get magnetic anomaly
+
+    inline void SetEta(G4double n) { eta = n; }
+    inline G4double GetEta() const { return eta; }
+      // set/get EDM eta parameter
+
+  private:
+
+    G4double fElectroMagCof ;
+    G4double fMassCof;
+
+    G4double omegac;
+    G4double anomaly;
+    G4double eta;
+    G4double ParticleCharge;
+    G4double E;
+    G4double gamma;
+    G4double beta;
+
+};
+
+#endif /* G4EQEMFIELDWITHEDM */
Index: /trunk/source/geometry/magneticfield/include/G4MonopoleEq.hh
===================================================================
--- /trunk/source/geometry/magneticfield/include/G4MonopoleEq.hh	(revision 1274)
+++ /trunk/source/geometry/magneticfield/include/G4MonopoleEq.hh	(revision 1274)
@@ -0,0 +1,74 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+//
+// $Id: G4MonopoleEq.hh,v 1.1 2009/11/17 09:53:03 grichine Exp $
+// GEANT4 tag $Name:  $
+//
+//
+// class G4MonopoleEq
+//
+// Class description:
+//
+// This is the right-hand side of equation of motion 
+// for monopole in a combined
+// electric and magnetic field.
+
+// History:
+// - Created. V.Grichine, 17.11.09
+// -------------------------------------------------------------------
+
+#ifndef G4EQMAGELECTRICFIELD_hh
+#define G4EQMAGELECTRICFIELD_hh
+
+#include "G4EquationOfMotion.hh"
+#include "G4ElectroMagneticField.hh"
+
+class G4MonopoleEq : public G4EquationOfMotion
+{
+  public:  // with description
+
+    G4MonopoleEq(G4ElectroMagneticField *emField )
+      : G4EquationOfMotion( emField ) {;}
+
+    ~G4MonopoleEq() {;} 
+
+    void  SetChargeMomentumMass(G4double particleCharge, // in e+ units
+                                G4double MomentumXc,
+                                G4double mass);
+
+    void EvaluateRhsGivenB(const G4double y[],
+                           const G4double Field[],
+                                 G4double dydx[] ) const;
+      // Given the value of the electromagnetic field, this function 
+      // calculates the value of the derivative dydx.
+
+  private:
+
+    G4double        fElectroMagCof ;
+    G4double        fMassCof;
+};
+
+#endif
Index: /trunk/source/geometry/magneticfield/include/G4NystromRK4.hh
===================================================================
--- /trunk/source/geometry/magneticfield/include/G4NystromRK4.hh	(revision 1274)
+++ /trunk/source/geometry/magneticfield/include/G4NystromRK4.hh	(revision 1274)
@@ -0,0 +1,134 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// $Id: G4NystromRK4.hh,v 1.3 2009/11/12 15:01:36 japost Exp $ 
+// GEANT4 tag $Name:  $
+//
+// class G4NystromRK4
+//
+// Class description:
+//
+// Integrate the equations of the motion of a particle in a magnetic field
+// using 4th Runge-Kutta-Nystrom method with errors estimation 
+// (ATL-SOFT-PUB-2009-01)
+// Current form can be used only for 'pure' magnetic field.
+// Notes: 1) field must be time-independent.
+//        2) time is not integrated
+// 
+// History:
+// - Created: I.Gavrilenko   15.05.2009   (as G4AtlasRK4)
+// - Adaptations:  J. Apostolakis  May-Nov 2009
+// -------------------------------------------------------------------
+
+#ifndef G4NYSTROMRK4_HH
+#define G4NYSTROMRK4_HH
+
+#include "globals.hh"
+#include "G4MagIntegratorStepper.hh"
+#include "G4Mag_EqRhs.hh"
+
+class G4NystromRK4 : public G4MagIntegratorStepper
+{
+  public: 
+    G4NystromRK4(G4Mag_EqRhs *EquationMotion, G4double distanceConstField=0.0); 
+      // Can be used only for Magnetic Fields - and for 6 variables (x,p)
+
+    ~G4NystromRK4() ;
+
+    void Stepper(const G4double P   [],
+	         const G4double dPdS[],
+	               G4double step  ,
+	               G4double Po  [],
+	               G4double Err []);
+      // Single call for integration result and error
+      // - Provides Error via analytical method
+
+    virtual void ComputeRightHandSide(const double P[],double dPdS[]);   
+      // Must compute RHS - and does caches result
+
+    void      SetDistanceForConstantField( G4double length ); 
+    G4double  GetDistanceForConstantField() const; 
+   
+    G4int     IntegratorOrder() const {return 4;}
+    G4double  DistChord() const; 
+  
+  private:
+
+    inline void getField   (const G4double P[4]);
+
+    ////////////////////////////////////////////////////////////////
+    // Private data
+    ////////////////////////////////////////////////////////////////
+
+    G4Mag_EqRhs*           m_fEq;          
+    G4double      m_lastField[3];
+    G4double      m_fldPosition[4];
+    G4double      m_magdistance ;
+    G4double      m_magdistance2;
+    G4double      m_cof         ;
+    G4double      m_mom         ;
+    G4double      m_imom        ;
+    G4bool        m_cachedMom   ;
+    G4double      m_iPoint   [3];
+    G4double      m_mPoint   [3];
+    G4double      m_fPoint   [3];
+    
+};
+
+/////////////////////////////////////////////////////////////////////////////////
+// Inline methods
+/////////////////////////////////////////////////////////////////////////////////
+inline void  G4NystromRK4::SetDistanceForConstantField( G4double length )
+{
+  m_magdistance=   length;
+  m_magdistance2 = length*length;
+}
+
+inline G4double  G4NystromRK4::GetDistanceForConstantField() const
+{
+  return m_magdistance; 
+}
+
+/////////////////////////////////////////////////////////////////////////////////
+// Get value of magnetic field while checking distance from last stored call
+/////////////////////////////////////////////////////////////////////////////////
+
+inline void G4NystromRK4::getField (const G4double P[4])
+{
+  
+  G4double dx = P[0]-m_fldPosition[0];
+  G4double dy = P[1]-m_fldPosition[1];
+  G4double dz = P[2]-m_fldPosition[2];
+
+  if((dx*dx+dy*dy+dz*dz) > m_magdistance2) {
+
+    m_fldPosition[0] = P[0];
+    m_fldPosition[1] = P[1];
+    m_fldPosition[2] = P[2];
+    m_fldPosition[3] = P[3];   //  Generally it is P[7] - changed convention !!
+    m_fEq->GetFieldValue(m_fldPosition, m_lastField);
+  }
+}
+#endif  // G4NYSTROMRK4
Index: /trunk/source/geometry/magneticfield/src/G4CachedMagneticField.cc
===================================================================
--- /trunk/source/geometry/magneticfield/src/G4CachedMagneticField.cc	(revision 1274)
+++ /trunk/source/geometry/magneticfield/src/G4CachedMagneticField.cc	(revision 1274)
@@ -0,0 +1,99 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+//
+// $Id: G4CachedMagneticField.cc,v 1.1 2009/11/05 11:06:13 japost Exp $
+// GEANT4 tag $Name:  $
+//
+// --------------------------------------------------------------------
+
+#include "G4CachedMagneticField.hh"
+
+G4CachedMagneticField::G4CachedMagneticField(G4MagneticField *pMagField, 
+					     G4double         distance)
+  : G4MagneticField(), 
+    fLastLocation(DBL_MAX,DBL_MAX,DBL_MAX),
+    fLastValue(DBL_MAX,DBL_MAX,DBL_MAX),
+    fCountCalls(0),  fCountEvaluations(0)
+{
+  fpMagneticField=     pMagField;
+  fDistanceConst= distance;
+
+  // G4cout << " Cached-B-Field constructor> Distance = " << distance << G4endl;
+  this->ClearCounts(); 
+}
+
+G4CachedMagneticField::~G4CachedMagneticField()
+{
+}
+
+void
+G4CachedMagneticField::ReportStatistics()
+{
+  G4cout << " Cached field: " << this << G4endl
+	 << "   Number of calls:        " << fCountCalls << G4endl
+	 << "   Number of evaluations : " << fCountEvaluations << G4endl;                     
+}
+
+G4CachedMagneticField::G4CachedMagneticField(const G4CachedMagneticField &rightCMF)
+  : G4MagneticField()
+{
+  fpMagneticField=      rightCMF.fpMagneticField;
+  fDistanceConst = rightCMF.fDistanceConst;
+  fLastLocation  = rightCMF.fLastLocation;
+  fLastValue     = rightCMF.fLastValue;
+  this->ClearCounts(); 
+}
+
+G4CachedMagneticField& G4CachedMagneticField::operator = (const G4CachedMagneticField &p)
+{
+  if (&p == this) return *this; *this = p; return *this;
+}
+
+void
+G4CachedMagneticField::GetFieldValue( const G4double Point[4],
+                                            G4double *Bfield ) const
+{
+  G4ThreeVector newLocation( Point[0], Point[1], Point[2] );
+
+  // G4cout << "Cache-B-field called at " << newLocation << G4endl;
+
+  G4double      distSq= (newLocation-fLastLocation).mag2();
+  fCountCalls++;
+  if( distSq < fDistanceConst*fDistanceConst ) { 
+     Bfield[0] = fLastValue.x();
+     Bfield[1] = fLastValue.y();
+     Bfield[2] = fLastValue.z();
+  }else{
+     // G4CachedMagneticField* thisNonC= const_cast<G4CachedMagneticField*>(this);
+     fpMagneticField->GetFieldValue( Point, Bfield );
+     // G4cout << " Evaluating. " << G4endl;
+     fCountEvaluations++;
+     // thisNonC->
+     fLastLocation= G4ThreeVector( Point[0],  Point[1],  Point[2] );
+     // thisNonC->
+     fLastValue=    G4ThreeVector( Bfield[0], Bfield[1], Bfield[2] );
+  }
+}
Index: /trunk/source/geometry/magneticfield/src/G4EqEMFieldWithEDM.cc
===================================================================
--- /trunk/source/geometry/magneticfield/src/G4EqEMFieldWithEDM.cc	(revision 1274)
+++ /trunk/source/geometry/magneticfield/src/G4EqEMFieldWithEDM.cc	(revision 1274)
@@ -0,0 +1,163 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+//
+// $Id: G4EqEMFieldWithEDM.cc,v 1.2 2009/11/06 22:31:54 gum Exp $
+// GEANT4 tag $Name:  $
+//
+//
+//  This is the standard right-hand side for equation of motion.
+//
+//  19.02.2009 Kevin Lynch, based on G4EqEMFieldWithSpin
+//  06.11.2009 Hiromi Iinuma see:
+//  http://hypernews.slac.stanford.edu/HyperNews/geant4/get/emfields/161.html
+//
+// -------------------------------------------------------------------
+
+#include "G4EqEMFieldWithEDM.hh"
+#include "G4ElectroMagneticField.hh"
+#include "G4ThreeVector.hh"
+#include "globals.hh"
+
+G4EqEMFieldWithEDM::G4EqEMFieldWithEDM(G4ElectroMagneticField *emField )
+      : G4EquationOfMotion( emField )
+{
+  anomaly = 0.0011659208;
+  eta = 0.;
+}
+
+G4EqEMFieldWithEDM::~G4EqEMFieldWithEDM()
+{
+} 
+
+void  
+G4EqEMFieldWithEDM::SetChargeMomentumMass(G4double particleCharge, // e+ units
+                                            G4double MomentumXc,
+                                            G4double particleMass)
+{
+   fElectroMagCof =  eplus*particleCharge*c_light ;
+   fMassCof = particleMass*particleMass ;
+
+   omegac = 0.105658387*GeV/particleMass * 2.837374841e-3*(rad/cm/kilogauss);
+
+   ParticleCharge = particleCharge;
+
+   E = std::sqrt(sqr(MomentumXc)+sqr(particleMass));
+   beta  = MomentumXc/E;
+   gamma = E/particleMass;
+
+}
+
+void
+G4EqEMFieldWithEDM::EvaluateRhsGivenB(const G4double y[],
+                                       const G4double Field[],
+                                             G4double dydx[] ) const
+{
+
+   // Components of y:
+   //    0-2 dr/ds,
+   //    3-5 dp/ds - momentum derivatives
+   //    9-11 dSpin/ds = (1/beta) dSpin/dt - spin derivatives
+
+   // The BMT equation, following J.D.Jackson, Classical
+   // Electrodynamics, Second Edition, with additions for EDM
+   // evolution from 
+   // M.Nowakowski, et.al. Eur.J.Phys.26, pp 545-560, (2005)
+   // or
+   // Silenko, Phys.Rev.ST Accel.Beams 9:034003, (2006)
+
+   // dS/dt = (e/m) S \cross 
+   // MDM:         [ (g/2-1 +1/\gamma) B
+   //               -(g/2-1)\gamma/(\gamma+1) (\beta \cdot B)\beta 
+   //               -(g/2-\gamma/(\gamma+1) \beta \cross E 
+   //
+   // EDM:        eta/2( E - gamma/(gamma+1) \beta (\beta \cdot E)
+   //                    + \beta \cross B ) ]
+   //
+   // where
+   // S = \vec{s}, where S^2 = 1
+   // B = \vec{B}
+   // \beta = \vec{\beta} = \beta \vec{u} with u^2 = 1
+   // E = \vec{E}
+
+   G4double pSquared = y[3]*y[3] + y[4]*y[4] + y[5]*y[5] ;
+
+   G4double Energy   = std::sqrt( pSquared + fMassCof );
+   G4double cof2     = Energy/c_light ;
+
+   G4double pModuleInverse  = 1.0/std::sqrt(pSquared) ;
+
+   G4double inverse_velocity = Energy * pModuleInverse / c_light;
+
+   G4double cof1     = fElectroMagCof*pModuleInverse ;
+
+   dydx[0] = y[3]*pModuleInverse ;                         
+   dydx[1] = y[4]*pModuleInverse ;                         
+   dydx[2] = y[5]*pModuleInverse ;                        
+
+   dydx[3] = cof1*(cof2*Field[3] + (y[4]*Field[2] - y[5]*Field[1])) ;
+   
+   dydx[4] = cof1*(cof2*Field[4] + (y[5]*Field[0] - y[3]*Field[2])) ; 
+ 
+   dydx[5] = cof1*(cof2*Field[5] + (y[3]*Field[1] - y[4]*Field[0])) ;  
+   
+   dydx[6] = dydx[8] = 0.;//not used
+
+   // Lab Time of flight
+   dydx[7] = inverse_velocity;
+   
+   G4ThreeVector BField(Field[0],Field[1],Field[2]);
+   G4ThreeVector EField(Field[3],Field[4],Field[5]);
+
+   EField /= c_light;
+
+   G4ThreeVector u(y[3], y[4], y[5]);
+   u *= pModuleInverse;
+
+   G4double udb = anomaly*beta*gamma/(1.+gamma) * (BField * u);
+   G4double ucb = (anomaly+1./gamma)/beta;
+   G4double uce = anomaly + 1./(gamma+1.);
+   G4double ude = beta*gamma/(1.+gamma)*(EField*u);
+
+   G4ThreeVector Spin(y[9],y[10],y[11]);
+
+   G4ThreeVector dSpin
+     = ParticleCharge*omegac*( ucb*(Spin.cross(BField))-udb*(Spin.cross(u))
+                               // from Jackson
+                               // -uce*Spin.cross(u.cross(EField)) )
+                               // but this form has one less operation
+                               - uce*(u*(Spin*EField) - EField*(Spin*u))
+                               +eta/2.*(Spin.cross(EField) - ude*(Spin.cross(u))
+                                        // +Spin.cross(u.cross(Bfield))
+				        + (u*(Spin*BField) - BField*(Spin*u))
+                                       )
+                             );
+			      
+   dydx[ 9] = dSpin.x();
+   dydx[10] = dSpin.y();
+   dydx[11] = dSpin.z();
+
+   return ;
+}
Index: /trunk/source/geometry/magneticfield/src/G4MonopoleEq.cc
===================================================================
--- /trunk/source/geometry/magneticfield/src/G4MonopoleEq.cc	(revision 1274)
+++ /trunk/source/geometry/magneticfield/src/G4MonopoleEq.cc	(revision 1274)
@@ -0,0 +1,99 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+//
+// $Id: G4MonopoleEq.cc,v 1.1 2009/11/17 09:53:03 grichine Exp $
+// GEANT4 tag $Name:  $
+//
+//
+//  This is the standard right-hand side for equation of motion.
+//
+//  d(p_c)/ds=g{c-energyB_ - p_c x E}/pc
+//
+//  The only case another is required is when using a moving reference
+//  frame ... or extending the class to include additional Forces,
+//  eg an electric field
+//
+//  17.11.09   V.Grichine
+//
+// -------------------------------------------------------------------
+
+#include "G4MonopoleEq.hh"
+#include "globals.hh"
+
+void  
+G4MonopoleEq::SetChargeMomentumMass(G4double particleCharge, // e+ units
+		                            G4double,
+                                            G4double particleMass)
+{
+  fElectroMagCof =  eplus*particleCharge;  // no *c_light as for ususal q
+  fElectroMagCof /= 2*fine_structure_const;
+
+  fMassCof = particleMass*particleMass ; 
+}
+
+
+
+void
+G4MonopoleEq::EvaluateRhsGivenB(const G4double y[],
+			                const G4double Field[],
+				              G4double dydx[] ) const
+{
+
+   // Components of y:
+   //    0-2 dr/ds, 
+   //    3-5 dpc/ds - momentum derivatives 
+
+   G4double pSquared = y[3]*y[3] + y[4]*y[4] + y[5]*y[5] ;
+
+   G4double Energy   = std::sqrt( pSquared + fMassCof );
+   G4double cof2     = Energy*c_light ;
+
+   G4double pModuleInverse  = 1.0/std::sqrt(pSquared) ;
+
+   //  G4double inverse_velocity = Energy * c_light * pModuleInverse;
+   G4double inverse_velocity = Energy * pModuleInverse / c_light;
+
+   G4double cof1     = fElectroMagCof*pModuleInverse ;
+
+   //  G4double vDotE = y[3]*Field[3] + y[4]*Field[4] + y[5]*Field[5] ;
+
+
+   dydx[0] = y[3]*pModuleInverse ;                         
+   dydx[1] = y[4]*pModuleInverse ;                         
+   dydx[2] = y[5]*pModuleInverse ;                        
+
+   dydx[3] = cof1*(cof2*Field[0] - (y[4]*Field[5] - y[5]*Field[4])) ;
+   
+   dydx[4] = cof1*(cof2*Field[1] - (y[5]*Field[3] - y[3]*Field[5])) ; 
+ 
+   dydx[5] = cof1*(cof2*Field[2] - (y[3]*Field[4] - y[4]*Field[3])) ;  
+
+   dydx[6] = 0.;//not used
+
+   // Lab Time of flight
+   dydx[7] = inverse_velocity;
+   return ;
+}
